/* gno3dtet: 3D Tetris game for GNOME
 * Copyright (C) 1999 Sebastien Nicoud <snicoud@rmi.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
*/

#ifndef _CSETTINGS
#define _CSETTINGS

#include "common.h"

class CSettings
{
// typedefs, consts
public:
	const enum { // from the easiest to the hardest
		diff_EASIEST_EXCLUDED,
		diff_EASY,
		diff_MEDIUM,
		diff_HARD,
		diff_HARDEST_EXCLUDED
	};
	static const gchar *diff_descriptors[5];
	static const gchar *str_width;
	static const gchar *str_height;
	static const gchar *str_depth;
	static const gchar *str_diff;

// attributes
public:
	gint	_w;
	gint	_h;
	gint	_d;
	gint	_total_cubes;
	gint	_difficulty;
	
// contructor
public:
	CSettings(); // constructeur par defaut
	CSettings(const CSettings &ins); // constructeur de copy
	
// destructor
	~CSettings();

// operators
public:
	CSettings &operator= (const CSettings &ins); // affectation de recopie
	friend ostream &operator<< (ostream &os, CSettings &ins); // output stream

// methods
public:
	gint compute_total_cubes(void) { _total_cubes = _w*_h*_d; return _total_cubes; };
private:
};

#endif
