/* gno3dtet: 3D Tetris game for GNOME
 * Copyright (C) 1999 Sebastien Nicoud <snicoud@rmi.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
*/

#ifndef _CWSETTINGS
#define _CWSETTINGS

#include "common.h"

class CWSettings
{
private:
	GtkWidget *_window;
	GtkWidget *_parent;
	CSettings *_settings_original;
	CSettings *_settings;
	GtkObject *_adj_width;
	GtkObject *_adj_height;
	GtkObject *_adj_depth;
	GtkWidget *label;

public:
	CWSettings();
	~CWSettings();
	
public:
	void init(GtkWidget *parent);
	void show(void);

private:
	void apply(void);
	void change_depth(void);
	void change_difficulty(gint d);
	void change_height(void);
	void change_width(void);
	void free_memory(void);
	void update_difficulty_label(void);
	
private: // callbacks
	static void cb_button_easy_clicked(GtkWidget *widget, gpointer data);
	static void cb_button_hard_clicked(GtkWidget *widget, gpointer data);
	static void cb_button_medium_clicked(GtkWidget *widget, gpointer data);
	static void cb_depth_value_changed(GtkWidget *widget, gpointer data);
	static void cb_height_value_changed(GtkWidget *widget, gpointer data);
	static void cb_width_value_changed(GtkWidget *widget, gpointer data);
	static void cb_apply_button_clicked(GtkWidget *widget, gint page_num,
		gpointer data);
};

#endif
